/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.veranstaltung.boundary;

import de.ivu.elect.business.veranstaltung.entity.Veranstaltung;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class VeranstaltungDAO extends AbstractVeranstaltungDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Veranstaltung veranstaltung){
    getEntityManager().persist(veranstaltung);
  }

  public void remove(Veranstaltung veranstaltung){
    getEntityManager().remove(veranstaltung);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                    
        /**
        * Name: GebietNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Veranstaltung o WHERE o.gebiet=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Veranstaltung> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Veranstaltung.findByGebiet" ,  gebiet  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByGebiet( gebiet  ));
        }
        return (java.util.List<Veranstaltung>) cached;
        }
            return super.findByGebiet( gebiet  );
            }
                                            
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}